package com.yaohun.demonskills.skills.youling;

import com.yaohun.demonskills.SkillsMain;
import com.yaohun.demonskills.component.DelayComponent;
import com.yaohun.demonskills.component.SoundComponent;
import com.yaohun.demonskills.component.damage.DamageComponent;
import com.yaohun.demonskills.component.dragoncore.PlayerAnimationComponent;
import com.yaohun.demonskills.component.dragoncore.StandAnimationComponent;
import com.yaohun.demonskills.component.effects.StunPlayerComponent;
import com.yaohun.demonskills.component.particles.ParticlesComponent;
import com.yaohun.demonskills.core.Skill;
import com.yaohun.demonskills.data.PlayerData;
import com.yaohun.demonskills.manage.PlayerManager;
import com.yaohun.demonskills.target.ConeEnemiesSelector;
import com.yaohun.demonskills.target.NearestEnemiesSelector;
import com.yaohun.demonskills.target.SelfSelector;
import org.bukkit.Particle;
import org.bukkit.entity.Player;
import org.serverct.ersha.jd.AttributeAPI;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public class Skill_剑舞八荒 {

    private static final String skillName = "剑舞八荒";
    private static final double cooldownTime = 25;
    private static final double cdReducePerLevel = 1.2;     // 每级减少1.2秒冷却
    private static final double minCooldown = 20.0;         // 最低冷却限制

    private static final Map<Integer, Integer> skillMagicMap = new HashMap<>();
    static {
        skillMagicMap.put(2, 1);
        skillMagicMap.put(3, 1);
        skillMagicMap.put(4, 2);
        skillMagicMap.put(5, 2);
        skillMagicMap.put(6, 3);
        skillMagicMap.put(7, 3);
        skillMagicMap.put(8, 4);
    }

    public static Skill getSkillItemStack(int skillLevel){
        double realCooldown = Math.max(cooldownTime - cdReducePerLevel * (skillLevel - 1), minCooldown);
        int realNeedMagic = skillMagicMap.getOrDefault(skillLevel, 1);
        return new Skill(skillName, realNeedMagic, realCooldown, 1.2,new ArrayList<>());
    }

    public static Skill getSkillData(Player player) {
        String playerName = player.getName();
        PlayerManager playerManager = SkillsMain.getPlayerManager();
        PlayerData playerData = playerManager.getPlayerData(playerName);
        int skillLevel = playerData.getSkillLevel(skillName);
        double realCooldown = Math.max(cooldownTime - cdReducePerLevel * (skillLevel - 1), minCooldown);
        int realNeedMagic = skillMagicMap.getOrDefault(skillLevel, 1);
        double damageValue = AttributeAPI.getAttrData(player).getAttributeRandomValue("物理伤害");
        double damage = ((0.2 * skillLevel) * damageValue + 50) + damageValue;
        Skill skill = new Skill( // 技能 ID
                skillName,   // 技能名称
                realNeedMagic,      // 魔力需求
                realCooldown,      // 冷却时间
                1.2,
                Arrays.asList(
                        // 技能组件列表
                        new StunPlayerComponent(new SelfSelector(), 20L), // 定身2.0秒
                        new PlayerAnimationComponent("剑舞八荒",20),
                        new StandAnimationComponent("@游灵剑技4", "youling_skill4", 1, 20,0.1),
                        new SoundComponent("刀飞舞.ogg", 0.4f, 1.0f),
                        new DelayComponent(4L,Arrays.asList(
                                new DamageComponent(damage * 0.2 ,new NearestEnemiesSelector(8.0)),
                                new DelayComponent(4L,Arrays.asList(
                                        new DamageComponent(damage * 0.2 ,new NearestEnemiesSelector(8.0)),
                                        new DelayComponent(4L,Arrays.asList(
                                                new DamageComponent(damage * 0.2 ,new NearestEnemiesSelector(8.0)),
                                                new ParticlesComponent(Particle.END_ROD,6,2,10),
                                                new DelayComponent(4L,Arrays.asList(
                                                        new DamageComponent(damage * 0.2 ,new NearestEnemiesSelector(8.0))
                                                ))
                                        ))
                                )
                        ))
                )));
        playerData.setCooldownData(skillName, realCooldown);
        return skill;
    }

}
