package com.yaohun.demonskills.skills.youling;

import com.yaohun.demonskills.SkillsMain;
import com.yaohun.demonskills.component.DelayComponent;
import com.yaohun.demonskills.component.PotionEffectComponent;
import com.yaohun.demonskills.component.SoundComponent;
import com.yaohun.demonskills.component.damage.DamageComponent;
import com.yaohun.demonskills.component.damage.DamageContinuedComponent;
import com.yaohun.demonskills.component.dragoncore.PlayerAnimationComponent;
import com.yaohun.demonskills.component.dragoncore.StandAnimationComponent;
import com.yaohun.demonskills.component.effects.StunPlayerComponent;
import com.yaohun.demonskills.component.particles.ParticlesComponent;
import com.yaohun.demonskills.component.projectile.ProjectilePullComponent;
import com.yaohun.demonskills.component.projectile.ProjectileVectorComponent;
import com.yaohun.demonskills.core.Skill;
import com.yaohun.demonskills.data.PlayerData;
import com.yaohun.demonskills.manage.PlayerManager;
import com.yaohun.demonskills.target.ConeEnemiesSelector;
import com.yaohun.demonskills.target.NearestEnemiesSelector;
import com.yaohun.demonskills.target.SelfSelector;
import org.bukkit.Particle;
import org.bukkit.entity.Player;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.util.Vector;
import org.serverct.ersha.jd.AttributeAPI;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public class Skill_幻刃屠龙舞 {

    private static final String skillName = "幻刃屠龙舞";
    private static final double cooldownTime = 40;
    private static final double cdReducePerLevel = 1.6;     // 每级减少1.2秒冷却
    private static final double minCooldown = 30.0;         // 最低冷却限制

    private static final Map<Integer, Integer> skillMagicMap = new HashMap<>();
    static {
        skillMagicMap.put(1, 1);
        skillMagicMap.put(2, 1);
        skillMagicMap.put(3, 2);
        skillMagicMap.put(4, 2);
        skillMagicMap.put(5, 3);
        skillMagicMap.put(6, 3);
        skillMagicMap.put(7, 4);
        skillMagicMap.put(8, 4);
    }

    public static Skill getSkillItemStack(int skillLevel){
        double realCooldown = Math.max(cooldownTime - cdReducePerLevel * (skillLevel - 1), minCooldown);
        int realNeedMagic = skillMagicMap.getOrDefault(skillLevel, 1);
        return new Skill(skillName, realNeedMagic, realCooldown, 3.2,new ArrayList<>());
    }

    public static Skill getSkillData(Player player) {
        String playerName = player.getName();
        PlayerManager playerManager = SkillsMain.getPlayerManager();
        PlayerData playerData = playerManager.getPlayerData(playerName);
        int skillLevel = playerData.getSkillLevel(skillName);
        double realCooldown = Math.max(cooldownTime - cdReducePerLevel * (skillLevel - 1), minCooldown);
        int realNeedMagic = skillMagicMap.getOrDefault(skillLevel, 1);
        double damageValue = AttributeAPI.getAttrData(player).getAttributeRandomValue("物理伤害");
        double damage = ((0.2 * skillLevel) * damageValue + 50) + damageValue;
        Skill skill = new Skill( // 技能 ID
                skillName,   // 技能名称
                realNeedMagic,      // 魔力需求
                realCooldown,      // 冷却时间
                3.2,
                Arrays.asList(
                        // 技能组件列表
                        new StunPlayerComponent(new SelfSelector(), 60L), // 定身2.0秒
                        new PlayerAnimationComponent("幻刃屠龙舞",60),
                        new StandAnimationComponent("@游灵剑技6", "youling_skill6", 1, 56,0.1),
                        new DelayComponent(10L,Arrays.asList(
                                new SoundComponent("挥舞剑气1.ogg", 0.4f, 1.0f),
                                new DamageComponent(damage * 0.2 ,new ConeEnemiesSelector(7.0,90)),
                                new ParticlesComponent(Particle.SPELL_WITCH,6,2,50,new ConeEnemiesSelector(7.0,90)),
                                new PotionEffectComponent(PotionEffectType.SLOW,50,5,new ConeEnemiesSelector(10.0,90)),
                                new DelayComponent(8L,Arrays.asList(
                                        new DamageComponent(damage * 0.2 ,new ConeEnemiesSelector(10.,90)),
                                        new SoundComponent("幻刃屠龙舞.ogg", 0.4f, 1.0f),
                                        new DamageContinuedComponent(damage*0.2,new ConeEnemiesSelector(10.,90),5,5L,10),
                                        new DelayComponent(20L,Arrays.asList(
                                                new ProjectileVectorComponent(new Vector(0,1,0),0,1.0,0,new ConeEnemiesSelector(10.0,90)),
                                                new DelayComponent(3L,Arrays.asList(
                                                        new DamageComponent(damage * 0.6,new ConeEnemiesSelector(13.0,90))
                                                ))
                                        ))
                                ))
                        )
                        )
                )
        );
        playerData.setCooldownData(skillName, realCooldown);
        return skill;
    }

}
