package com.yaohun.demonskills.skills.youling;

import com.yaohun.demonskills.SkillsMain;
import com.yaohun.demonskills.component.DelayComponent;
import com.yaohun.demonskills.component.SoundComponent;
import com.yaohun.demonskills.component.damage.DamageComponent;
import com.yaohun.demonskills.component.dragoncore.ParticleSpawnCommponent;
import com.yaohun.demonskills.component.dragoncore.PlayerAnimationComponent;
import com.yaohun.demonskills.component.dragoncore.StandAnimationComponent;
import com.yaohun.demonskills.component.effects.StunPlayerComponent;
import com.yaohun.demonskills.component.particles.ParticlesComponent;
import com.yaohun.demonskills.core.Skill;
import com.yaohun.demonskills.data.PlayerData;
import com.yaohun.demonskills.manage.PlayerManager;
import com.yaohun.demonskills.target.ConeEnemiesSelector;
import com.yaohun.demonskills.target.SelfSelector;
import org.bukkit.Particle;
import org.bukkit.entity.Player;
import org.serverct.ersha.jd.AttributeAPI;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public class Skill_逐风三式 {

    private static final String skillName = "逐风三式";
    private static final double cooldownTime = 15;
    private static final double cdReducePerLevel = 1.6;     // 每级减少1.2秒冷却
    private static final double minCooldown = 5.5;         // 最低冷却限制

    private static final Map<Integer, Integer> skillMagicMap = new HashMap<>();
    static {
        skillMagicMap.put(3, 1);
        skillMagicMap.put(4, 1);
        skillMagicMap.put(5, 2);
        skillMagicMap.put(6, 2);
        skillMagicMap.put(7, 3);
        skillMagicMap.put(8, 3);
    }

    public static Skill getSkillItemStack(int skillLevel){
        double realCooldown = Math.max(cooldownTime - cdReducePerLevel * (skillLevel - 1), minCooldown);
        int realNeedMagic = skillMagicMap.getOrDefault(skillLevel, 1);
        return new Skill(skillName, realNeedMagic, realCooldown, 1.5,new ArrayList<>());
    }

    public static Skill getSkillData(Player player) {
        String playerName = player.getName();
        PlayerManager playerManager = SkillsMain.getPlayerManager();
        PlayerData playerData = playerManager.getPlayerData(playerName);
        int skillLevel = playerData.getSkillLevel(skillName);
        double realCooldown = Math.max(cooldownTime - cdReducePerLevel * (skillLevel - 1), minCooldown);
        int realNeedMagic = skillMagicMap.getOrDefault(skillLevel, 1);
        double damageValue = AttributeAPI.getAttrData(player).getAttributeRandomValue("物理伤害");
        double damage = ((0.2 * skillLevel) * damageValue + 50) + damageValue;
        Skill skill = new Skill( // 技能 ID
                skillName,   // 技能名称
                realNeedMagic,      // 魔力需求
                realCooldown,      // 冷却时间
                1.5,
                Arrays.asList(
                        // 技能组件列表
                        new PlayerAnimationComponent("逐风三式",25),
                        new StandAnimationComponent("@游灵剑技1", "youling_skill1", 1, 25,0.1),
                        new SoundComponent("宝剑挥舞.ogg", 0.4f, 1.0f),
                        new DelayComponent(5L,Arrays.asList(
                                new DamageComponent(damage * 0.2 ,new ConeEnemiesSelector(6.5,45)),
                                new SoundComponent("宝剑挥舞.ogg", 0.4f, 1.0f),
                                new DelayComponent(5L,Arrays.asList(
                                        new DamageComponent(damage * 0.2,new ConeEnemiesSelector(6.5,45)),
                                        new SoundComponent("宝剑挥舞.ogg", 0.4f, 1.0f),
                                        new DelayComponent(5L,Arrays.asList(
                                                new DamageComponent(damage * 0.2,new ConeEnemiesSelector(6.5,45)),
                                                new SoundComponent("宝剑挥舞.ogg", 0.4f, 1.0f)
                                        ))
                                )
                        ))
                )));
        playerData.setCooldownData(skillName, realCooldown);
        return skill;
    }

}
